image: docker:latest

services:
  - docker:dind

variables:
  DOCKER_DRIVER: overlay2
  CONTAINER_TEST_IMAGE: $CI_DOCKER_REGISTRY/$CI_PATH/$CI_PROJECT_NAME:$CI_COMMIT_REF_SLUG

#before_script:
#  - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY

stages:
  - build
  - deploy

build:
  stage: build
  tags: 
    - docker
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_DOCKER_REGISTRY
    - docker build --pull -t "$CONTAINER_TEST_IMAGE" .
    - docker push "$CONTAINER_TEST_IMAGE"

deploy:
  stage: deploy
  tags:
    - docker
  image: argoproj/argocd:v2.4.0
  before_script:
    - argocd login $ARGOCD_SERVER --username $ARGOCD_USER --password $ARGOCD_PASS --grpc-web --insecure
  script:
    - argocd app set $CI_PROJECT_NAME-test -p name=$CI_PROJECT_NAME -p tag=$CI_COMMIT_REF_SLUG 
#    - sleep 30; if [ $(argocd app list |grep $CI_PROJECT_NAME-test | awk '{print $6}') != "Healthy" ]; then echo "Service failed, see service logs for details"; exit 1; else echo "OK"; fi;
  variables:
    NAMESPACE: otus-app
  when: manual


